<template>
  <a-modal
    :visible="visible"
    :confirm-loading="loading"
    @cancel="handleCancel"
    @ok="handleOK"
    title="Điều chỉnh Tư vấn viên"
    ok-text="Đồng ý"
  >
    <a-form :form="form" layout="vertical">
      <a-form-item v-bind="formItemLayout">
        <template slot="label">
          <span>Tư vấn viên</span>
        </template>
        <a-select
          v-decorator="['consultantId', formItemOption.consultantId]"
          :get-popup-container="triggerNode => triggerNode.parentNode"
          placeholder="Tư vấn viên"
        >
          <a-select-option v-for="s in consultants" :key="s.id">
            {{ s.gender | NamePrefix }}{{ s.name }}
          </a-select-option>
        </a-select>
      </a-form-item>
    </a-form>
  </a-modal>
</template>
<script>
import { mapGetters } from 'vuex'
import { ehrApi } from '@/api'
export default {
  name: 'ChangeConsultantDialog',
  props: {
    submit: {
      type: Function,
      default: () => {}
    }
  },
  data () {
    return {
      visible: false,
      loading: false,
      consultantId: null,
      consultants: [],
      id: null
    }
  },
  computed: {
    ...mapGetters('auth', ['userId', 'role', 'isAdmin']),
    formItemLayout: () => ({}),
    rules () {
      return {
        consultantId: [
          { required: true, message: 'Vui lòng chọn Tư vấn viên' }
        ]
      }
    },
    formItemOption () {
      const { rules } = this
      return {
        consultantId: {
          rules: rules.consultantId,
          initialValue: (+this.consultantId) || ''
        }
      }
    }
  },
  beforeCreate () {
    this.form = this.$form.createForm(this)
  },
  async created () {
    if (this.isAdmin) {
      const filter = {
        where: {},
        limit: 1000,
        order: 'name ASC'
      }
      const { data } = await ehrApi.admin.getConsultants({ filter })
      this.consultants = data
    }
  },
  methods: {
    show ({ id, consultantId }) {
      this.visible = true
      this.consultantId = +consultantId
      this.id = id
    },
    reset () {
      this.form.resetFields()
      this.visible = false
      this.consultantId = null
    },
    handleCancel () {
      this.visible = false
      this.loading = false
      this.reset()
    },
    handleOK (e) {
      e.preventDefault()
      this.form.validateFields(async (err, values) => {
        if (err) {
          return
        }
        const payload = {
          id: this.id,
          consultantId: +values.consultantId
        }
        console.log(values)
        await this.submit(payload)
        this.loading = false
        this.reset()
      })
    }
  }
}
</script>
